/*
 * ComplaintTypeListener.java
 *
 * Created on 10 de agosto de 2004, 18:17
 */

package com.fenalco.servlets.sysmanager;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.ComplaintCategory;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;

/**
 * 
 * @author andres
 * @version
 */
public class ComplaintTypeListener extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones de los mčtodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Recibe del request el parámtero operationType que indica el tipo de
	 * operación a ejecutar
	 * 
	 * 1)"new" -Redirecciona a nuevotiporeclamo.jsp
	 * 
	 * 2)"delete" -Manda en el request el parámetro operationType con el valor
	 * "delete" -Redirecciona a administrartiposreclamo
	 * 
	 * 3)"update" y recibe el id de un tipo de reclamo (complaintCategoryId)
	 * -Crea el objeto complaintCategory de tipo <CODE>ComplaintCategory
	 * </CODE> con el id que recibe -Manda el objeto en el request -Redirecciona
	 * a modificartiporeclamo.jsp
	 * 
	 * @param request
	 *            peticiňn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String url = "";
		String message = "";
		HttpSession session = request.getSession(false);
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 1 )
			{
				url = "/index.jsp";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
	
				String operationType = request.getParameter("operationType");
				System.out.println("operation->" + operationType);
				if( operationType.equals("new") )
				{
					url = "/administrador/nuevotiporeclamo.jsp";
				}
				else
					if( operationType.equals("delete") )
					{
						url = "/administrador/administrartiposreclamo";
	
					}
					else
						if( operationType.equals("update") )
						{
							int complaintCategoryId = Integer.parseInt(request
									.getParameter("key"));
							ComplaintCategory complaintCategory = new ComplaintCategory(
									complaintCategoryId);
							url = "/administrador/modificartiporeclamo.jsp";
							request.setAttribute("complaintCategory",
									complaintCategory);
						}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el mčtodo HTTP <code>GET</code>
	 * 
	 * @param request
	 *            peticiňn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el mčtodo HTTP <code>POST</code>
	 * 
	 * @param request
	 *            peticiňn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una corta descripciňn del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}